## jeolib-miallib 1.1.6

=== CMakeLists.txt ===
###############################################################################
# Author(s): Pieter.Kempeneers@ec.europa.eu
# Copyright (C) 2000-2023 European Union (Joint Research Centre)

# This file is part of miallib.

# miallib is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# miallib is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with miallib.  If not, see <https://www.gnu.org/licenses/>.
###############################################################################

## need to install
# libopenblas-dev
# libfftw3-mpi-dev

cmake_minimum_required(VERSION 3.15)

# The project's name and version
project(miallib)

# set(MIALLIB_LIB_NAME miallib_generic)
set(MIALLIB_LIB_NAME miallib)

set (MIALLIB_VERSION_MAJOR 1)
set (MIALLIB_VERSION_MINOR 1)
set (MIALLIB_VERSION_PATCH 6)
set (MIALLIB_VERSION "${MIALLIB_VERSION_MAJOR}.${MIALLIB_VERSION_MINOR}.${MIALLIB_VERSION_PATCH}")
set (MIALLIB_SOVERSION "${MIALLIB_VERSION_MAJOR}")

set(PROCESS_IN_PARALLEL TRUE CACHE BOOL "Choose if miallib should be run in parallel")

# build a CPack driven installer package
INCLUDE (InstallRequiredSystemLibraries)
SET(CPACK_COMPONENTS_ALL libraries headers)
SET(CPACK_RESOURCE_FILE_LICENSE
     "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
SET(CPACK_PACKAGE_VERSION_MAJOR "${MIALLIB_VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${MIALLIB_VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${MIALLIB_VERSION_PATCH}")
SET(CPACK_GENERATOR "DEB")
SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "Pieter Kempeneers")
SET(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
# Set files to ignore
list(APPEND CPACK_SOURCE_IGNORE_FILES "_CPack_Packages")
list(APPEND CPACK_SOURCE_IGNORE_FILES ".gz")
list(APPEND CPACK_SOURCE_IGNORE_FILES ".bz2")
list(APPEND CPACK_SOURCE_IGNORE_FILES ".zip")
list(APPEND CPACK_SOURCE_IGNORE_FILES ".svn")
list(APPEND CPACK_SOURCE_IGNORE_FILES ".git")
list(APPEND CPACK_SOURCE_IGNORE_FILES "HOWTORELEASE.txt")
list(APPEND CPACK_SOURCE_IGNORE_FILES "CMakeCache.txt")
list(APPEND CPACK_SOURCE_IGNORE_FILES "CPackConfig.cmake")
list(APPEND CPACK_SOURCE_IGNORE_FILES "schemas")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/build/;~$;${CPACK_SOURCE_IGNORE_FILES}")

SET(CPACK_DEB_COMPONENT_INSTALL YES)
INCLUDE(CPack)
CPACK_ADD_COMPONENT(libraries)
CPACK_ADD_COMPONENT(headers)
SET(CPACK_DEB_COMPONENT_INSTALL YES)
SET(CPACK_COMPONENTS_ALL libraries headers)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/modules")
message(STATUS "cmake module path: ${CMAKE_MODULE_PATH}")

set(MIALLIB_SRC_DIR ${PROJECT_SOURCE_DIR}/core/c)

#simple way to get all src files, but not recommended
# file(GLOB SRC_FILES ${PROJECT_SOURCE_DIR}/core/*.c")
# set(SOURCES
#   ${SRC_FILES}
#   )

set(MIALLIB_H
  ${MIALLIB_SRC_DIR}/miallib_convolve.h
  ${MIALLIB_SRC_DIR}/miallib_dem.h
  ${MIALLIB_SRC_DIR}/miallib_dist.h
  ${MIALLIB_SRC_DIR}/miallib_erodil.h
  ${MIALLIB_SRC_DIR}/miallib_format.h
  ${MIALLIB_SRC_DIR}/miallib_geodesy.h
  ${MIALLIB_SRC_DIR}/miallib_geometry.h
  ${MIALLIB_SRC_DIR}/miallib_hmt.h
  ${MIALLIB_SRC_DIR}/miallib_imem.h
  ${MIALLIB_SRC_DIR}/miallib_io.h
  ${MIALLIB_SRC_DIR}/miallib_label.h
  ${MIALLIB_SRC_DIR}/miallib_miscel.h
  ${MIALLIB_SRC_DIR}/miallib_opclo.h
  ${MIALLIB_SRC_DIR}/miallib_pointop.h
  ${MIALLIB_SRC_DIR}/miallib_proj.h
  ${MIALLIB_SRC_DIR}/miallib_segment.h
  ${MIALLIB_SRC_DIR}/miallib_stats.h
  ${MIALLIB_SRC_DIR}/miallib_swig.h
  ${MIALLIB_SRC_DIR}/mialtypes.h
  ${MIALLIB_SRC_DIR}/myhull.h
  ${MIALLIB_SRC_DIR}/op.h
  )

set(SOURCES
  ${MIALLIB_H}
  ${MIALLIB_SRC_DIR}/aflood.c
  ${MIALLIB_SRC_DIR}/alphacc.c
  ${MIALLIB_SRC_DIR}/alphatree.c
  ${MIALLIB_SRC_DIR}/alphatreetoCCs.c
  ${MIALLIB_SRC_DIR}/base.h
  ${MIALLIB_SRC_DIR}/b_def.h
  ${MIALLIB_SRC_DIR}/borderdetection.c
  ${MIALLIB_SRC_DIR}/borderdetection.h
  ${MIALLIB_SRC_DIR}/bresenham.c
  ${MIALLIB_SRC_DIR}/b_undef.h
  ${MIALLIB_SRC_DIR}/bytesex.h
  ${MIALLIB_SRC_DIR}/ced.c
  ${MIALLIB_SRC_DIR}/classification.c
  ${MIALLIB_SRC_DIR}/colconv.c
  ${MIALLIB_SRC_DIR}/complete.c
  ${MIALLIB_SRC_DIR}/compose.c
  ${MIALLIB_SRC_DIR}/convolve.c
  ${MIALLIB_SRC_DIR}/dbscan.c
  ${MIALLIB_SRC_DIR}/dcluster.c
  ${MIALLIB_SRC_DIR}/d_def.h
  ${MIALLIB_SRC_DIR}/dendro.c
  ${MIALLIB_SRC_DIR}/determineSize.c
  ${MIALLIB_SRC_DIR}/determineSize.h
  ${MIALLIB_SRC_DIR}/dirmean.c
  ${MIALLIB_SRC_DIR}/dist.c
  ${MIALLIB_SRC_DIR}/douglas-peucker.c
  ${MIALLIB_SRC_DIR}/douglas-peucker.h
  ${MIALLIB_SRC_DIR}/d_undef.h
  ${MIALLIB_SRC_DIR}/edgeweight.c
  ${MIALLIB_SRC_DIR}/efedt.c
  ${MIALLIB_SRC_DIR}/epc.c
  ${MIALLIB_SRC_DIR}/erodil.c
  ${MIALLIB_SRC_DIR}/fah.c
  ${MIALLIB_SRC_DIR}/fah.h
  ${MIALLIB_SRC_DIR}/f_def.h
  ${MIALLIB_SRC_DIR}/fifo.c
  ${MIALLIB_SRC_DIR}/fifo.h
  ${MIALLIB_SRC_DIR}/fillocarve.c
  ${MIALLIB_SRC_DIR}/flatdir.c
  ${MIALLIB_SRC_DIR}/flow.c
  ${MIALLIB_SRC_DIR}/format.c
  ${MIALLIB_SRC_DIR}/f_undef.h
  ${MIALLIB_SRC_DIR}/g32_def.h
  ${MIALLIB_SRC_DIR}/g32_undef.h
  ${MIALLIB_SRC_DIR}/g_def.h
  ${MIALLIB_SRC_DIR}/geodist.c
  ${MIALLIB_SRC_DIR}/geom.c
  ${MIALLIB_SRC_DIR}/ggeo.c
  ${MIALLIB_SRC_DIR}/grid.c
  ${MIALLIB_SRC_DIR}/gsl.c
  ${MIALLIB_SRC_DIR}/g_undef.h
  ${MIALLIB_SRC_DIR}/herkbl.c
  ${MIALLIB_SRC_DIR}/herk.c
  ${MIALLIB_SRC_DIR}/histo.c
  ${MIALLIB_SRC_DIR}/htop.c
  ${MIALLIB_SRC_DIR}/hull.c
  ${MIALLIB_SRC_DIR}/hullti.c
  ${MIALLIB_SRC_DIR}/i32_def.h
  ${MIALLIB_SRC_DIR}/i32_undef.h
  ${MIALLIB_SRC_DIR}/i64_def.h
  ${MIALLIB_SRC_DIR}/i64_undef.h
  ${MIALLIB_SRC_DIR}/imem.c
  ${MIALLIB_SRC_DIR}/imio2.c
  ${MIALLIB_SRC_DIR}/imio.c
  ${MIALLIB_SRC_DIR}/imio_gdal.c
  ${MIALLIB_SRC_DIR}/imio.h
  ${MIALLIB_SRC_DIR}/imstat.c
  ${MIALLIB_SRC_DIR}/indexx.c
  ${MIALLIB_SRC_DIR}/label.c
  ${MIALLIB_SRC_DIR}/labelccdissim.c
  ${MIALLIB_SRC_DIR}/labelccfastrim.c
  ${MIALLIB_SRC_DIR}/labelccmi.c
  ${MIALLIB_SRC_DIR}/labelccms.c
  ${MIALLIB_SRC_DIR}/labelccmsdissim.c
  ${MIALLIB_SRC_DIR}/labelccvar.c
  ${MIALLIB_SRC_DIR}/labelci.c
  ${MIALLIB_SRC_DIR}/labelcims.c
  ${MIALLIB_SRC_DIR}/labelvertex.c
  ${MIALLIB_SRC_DIR}/lerodil.c
  ${MIALLIB_SRC_DIR}/linepool.c
  ${MIALLIB_SRC_DIR}/ll_def.h
  ${MIALLIB_SRC_DIR}/ll_undef.h
  ${MIALLIB_SRC_DIR}/mblincomb.c
  ${MIALLIB_SRC_DIR}/mcisrg.c
  ${MIALLIB_SRC_DIR}/mcisrg.h
  ${MIALLIB_SRC_DIR}/miallib.h
  ${MIALLIB_SRC_DIR}/miscel.c
  ${MIALLIB_SRC_DIR}/mmlabel.c
  ${MIALLIB_SRC_DIR}/mslabel.c
  ${MIALLIB_SRC_DIR}/mslabel.h
  ${MIALLIB_SRC_DIR}/msmm.c
  ${MIALLIB_SRC_DIR}/mspa.c
  ${MIALLIB_SRC_DIR}/myhull.cc
  ${MIALLIB_SRC_DIR}/myhull.h
  ${MIALLIB_SRC_DIR}/natngbint.c
  ${MIALLIB_SRC_DIR}/newlabelcc.c
  ${MIALLIB_SRC_DIR}/oiht.c
  ${MIALLIB_SRC_DIR}/oiiz.c
  ${MIALLIB_SRC_DIR}/oiws.c
  ${MIALLIB_SRC_DIR}/outeredge.c
  ${MIALLIB_SRC_DIR}/ovlmatrix.c
  ${MIALLIB_SRC_DIR}/partition.c
  ${MIALLIB_SRC_DIR}/partorp.c
  ${MIALLIB_SRC_DIR}/phase_correlation.c
  ${MIALLIB_SRC_DIR}/pointop.c
  ${MIALLIB_SRC_DIR}/pqueue.c
  ${MIALLIB_SRC_DIR}/pqueueExact.c
  ${MIALLIB_SRC_DIR}/pqueueExact.h
  ${MIALLIB_SRC_DIR}/pqueue.h
  ${MIALLIB_SRC_DIR}/projection.c
  ${MIALLIB_SRC_DIR}/propagate.c
  ${MIALLIB_SRC_DIR}/rank.c
  ${MIALLIB_SRC_DIR}/recons.c
  ${MIALLIB_SRC_DIR}/regionMean.c
  ${MIALLIB_SRC_DIR}/regionMean.h
  ${MIALLIB_SRC_DIR}/registration.c
  ${MIALLIB_SRC_DIR}/remsens.c
  ${MIALLIB_SRC_DIR}/rminmax.c
  ${MIALLIB_SRC_DIR}/s_def.h
  ${MIALLIB_SRC_DIR}/segmentation.c
  ${MIALLIB_SRC_DIR}/segmentation.h
  ${MIALLIB_SRC_DIR}/setreg.c
  ${MIALLIB_SRC_DIR}/setreglut.c
  ${MIALLIB_SRC_DIR}/setshft.c
  ${MIALLIB_SRC_DIR}/shade.c
  ${MIALLIB_SRC_DIR}/shm.c
  ${MIALLIB_SRC_DIR}/simplifyLine.c
  ${MIALLIB_SRC_DIR}/simplifyLine.h
  ${MIALLIB_SRC_DIR}/skel.c
  ${MIALLIB_SRC_DIR}/skelodthin.c
  ${MIALLIB_SRC_DIR}/srg.c
  ${MIALLIB_SRC_DIR}/s_undef.h
  ${MIALLIB_SRC_DIR}/switch.c
  ${MIALLIB_SRC_DIR}/transition.c
  ${MIALLIB_SRC_DIR}/u32_def.h
  ${MIALLIB_SRC_DIR}/u32_undef.h
  ${MIALLIB_SRC_DIR}/u64_def.h
  ${MIALLIB_SRC_DIR}/u64_undef.h
  ${MIALLIB_SRC_DIR}/uc_def.h
  ${MIALLIB_SRC_DIR}/uc_undef.h
  ${MIALLIB_SRC_DIR}/us_def.h
  ${MIALLIB_SRC_DIR}/us_undef.h
  ${MIALLIB_SRC_DIR}/uswilk.c
  ${MIALLIB_SRC_DIR}/vectorize.c
  ${MIALLIB_SRC_DIR}/vectorize.h
  ${MIALLIB_SRC_DIR}/writeShapeFile.c
  ${MIALLIB_SRC_DIR}/writeShapeFile.h
  ${MIALLIB_SRC_DIR}/writeSVG.c
  ${MIALLIB_SRC_DIR}/writeSVG.h
  ${MIALLIB_SRC_DIR}/wsfah.c
  ${MIALLIB_SRC_DIR}/wshed.c
  )
# core/c/banner.h

message(STATUS "SOURCES: ${SOURCES}")
# Setup output directories.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)


option (BUILD_SHARED_LIBS "Build with shared library" ON)
###############################################################################
# Define the miallib library.
# add_library( ${MIALLIB_LIB_NAME} ${SRC_FILES})
add_library(${MIALLIB_LIB_NAME} ${SOURCES})
###############################################################################

SET_TARGET_PROPERTIES(${MIALLIB_LIB_NAME}
  PROPERTIES
  SOVERSION ${MIALLIB_SOVERSION}
  VERSION ${MIALLIB_VERSION}
  NAMESPACE ${MIALLIB_LIB_NAME}::
  )

include_directories("core/c")

find_package(PkgConfig REQUIRED)

# Setup configure file
# configure a header file to pass some of the CMake settings to the source code

configure_file ( "cmake-config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/core/c/config_miallib.h")
# configure_file ( "cmake-config.in" "${CMAKE_CURRENT_BINARY_DIR}/miallib-config" @ONLY )
include_directories("${CMAKE_CURRENT_BINARY_DIR}/core/c")# needed for config_miallib.h
add_definitions(-DHAVE_CONFIG_H)

include(GNUInstallDirs)
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/miallib
  CACHE PATH "Location of header files" )
set(LIBRARY_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}
  CACHE PATH "Location of library files" )

#Generating Package Files
include(CMakePackageConfigHelpers)

configure_package_config_file(
  miallib-config.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/miallib-config.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/miallib
  PATH_VARS INCLUDE_INSTALL_DIR LIBRARY_INSTALL_DIR
  )

# Generate MIALLIBConfigVersion.cmake
write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/miallib-config-version.cmake
  VERSION ${MIALLIB_VERSION}
  COMPATIBILITY AnyNewerVersion
  )

configure_file ( "cmake.pc.in" "miallib.pc"  @ONLY)

find_package(ZLIB REQUIRED)
target_link_libraries(${MIALLIB_LIB_NAME} ${ZLIB_LIBRARIES})
include_directories(${ZLIB_INCLUDE_DIRS})
message(STATUS "Found ZLIB_INCLUDE_DIRS: ${ZLIB_INCLUDE_DIRS}")

find_package(GDAL 3.00 REQUIRED)
target_link_libraries(${MIALLIB_LIB_NAME} ${GDAL_LIBRARIES})
include_directories(${GDAL_INCLUDE_DIRS})

find_package(GeoTIFF)
message(STATUS "Found GEOTIFF_INCLUDE_DIRS: ${GEOTIFF_INCLUDE_DIRS}")
include_directories(${GEOTIFF_INCLUDE_DIR})
target_link_libraries(${MIALLIB_LIB_NAME} ${GEOTIFF_LIBRARIES})

find_package(TIFF)
target_link_libraries(${MIALLIB_LIB_NAME} tiff)

find_package(PROJ REQUIRED IMPORTED)
message(STATUS "Found PROJ INCLUDE DIRS: ${PROJ_INCLUDE_DIRS}")
target_link_libraries(${MIALLIB_LIB_NAME} ${PROJ_LIBRARIES})


message(STATUS "Found DL_LIBS: ${CMAKE_DL_LIBS}")
target_link_libraries(${MIALLIB_LIB_NAME} ${CMAKE_DL_LIBS})


### BEGIN FFTW

pkg_search_module(FFTW REQUIRED fftw3 IMPORTED_TARGET)
include_directories(PkgConfig::FFTW)
link_libraries(PkgConfig::FFTW)

#find_package(FFTW REQUIRED)
message(STATUS "Found FFTW_LIBRARIES: ${FFTW_LIBRARIES}")
message(STATUS "Found FFTW_INCLUDE_DIRS: ${FFTW_INCLUDE_DIRS}")
target_link_libraries(${MIALLIB_LIB_NAME} ${FFTW_LIBRARIES})

if(PROCESS_IN_PARALLEL)
  find_package(OpenMP REQUIRED)

=== debian/changelog ===
jeolib-miallib (1.1.6-2) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Team upload.
  * Add patch to fix FTBFS with GCC 15.
    (closes: #1096871)
  * Add symbols file.
  * Update lintian overrides.
  * Strip build path from miallib-config.cmake.
  * Add patch to fix spelling errors.

  [ Francesco Paolo Lovergine ]
  * Minimal changes to descriptions in d/control.
  * Fixed d/rules to manage correctly the .cmake output file (needs a proper
    fix in CMakeLists.txt)

 -- Francesco Paolo Lovergine <frankie@debian.org>  Mon, 24 Feb 2025 20:51:47 +0100

jeolib-miallib (1.1.6-1) unstable; urgency=medium

  * New upstream release with more changes to original myhull.c module.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 25 Sep 2024 17:40:48 +0200

jeolib-miallib (1.1.5-2) unstable; urgency=medium

  * Updated d/copyright to reflect removing of non-free chull.c source file.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 11 Sep 2024 18:29:19 +0200

jeolib-miallib (1.1.5-1) unstable; urgency=medium

  * New upstream version, with removing ofi a non-free file (closes: #1074409).
  * Debian patch for std99 merged upstream.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 11 Sep 2024 12:36:10 +0200

jeolib-miallib (1.1.3-1) unstable; urgency=medium

  * Initial release. 

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 03 Jul 2024 15:58:31 +0200

=== debian/control ===
Source: jeolib-miallib
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libfann-dev,
               libfftw3-dev,
               libgdal-dev,
               libgeotiff-dev,
               libgsl-dev,
               libjsoncpp-dev,
               libopenblas-dev,
               libproj-dev,
               libshp-dev,
               libssl-dev,
               pkgconf,
               swig,
               uthash-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/jeolib-miallib
Vcs-Git: https://salsa.debian.org/debian-gis-team/jeolib-miallib.git
Homepage: https://github.com/ec-jrc/jeolib-miallib
Rules-Requires-Root: no

Package: libmiallib-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libmiallib1 (= ${binary:Version}),
         ${misc:Depends}
Recommends: pkgconf
Description: JRC morphological and image processing library - Development files
 Miallib is a C library including image processing and 
 mathematical morphology algorithms used by Join Research Center
 in their Big Data Analytics Platform, with binding for Python
 provided.
 .
 This package contains the files needed to develop a software that
 will use the Miallib (headers, static objects, configuration script).

Package: libmiallib1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: JRC morphological and image processing library
 Miallib is a C library including image processing and 
 mathematical morphology algorithms used by Join Research Center
 in their Big Data Analytics Platform, with binding for Python
 provided.
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND = -Wno-deprecated-declarations
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	-DCMAKE_INSTALL_PREFIX=/usr \
 	-DINCLUDE_INSTALL_DIR=include/miallib \
 	-DLIBRARY_INSTALL_DIR=usr/lib/$(DEB_BUILD_MULTIARCH) \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo

execute_after_dh_auto_install:
	sed -i -e "s|$(CURDIR)/build||g" -e "s|/include|/usr/include|" debian/tmp/usr/lib/*/cmake/miallib/miallib-config.cmake

## jeolib-miallib 1.1.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
 
 set (MIALLIB_VERSION_MAJOR 1)
 set (MIALLIB_VERSION_MINOR 1)
-set (MIALLIB_VERSION_PATCH 6)
+set (MIALLIB_VERSION_PATCH 7)
 set (MIALLIB_VERSION "${MIALLIB_VERSION_MAJOR}.${MIALLIB_VERSION_MINOR}.${MIALLIB_VERSION_PATCH}")
 set (MIALLIB_SOVERSION "${MIALLIB_VERSION_MAJOR}")
 
@@ -198,7 +198,7 @@
   ${MIALLIB_SRC_DIR}/mslabel.h
   ${MIALLIB_SRC_DIR}/msmm.c
   ${MIALLIB_SRC_DIR}/mspa.c
-  ${MIALLIB_SRC_DIR}/myhull.cc
+  ${MIALLIB_SRC_DIR}/myhull.c
   ${MIALLIB_SRC_DIR}/myhull.h
   ${MIALLIB_SRC_DIR}/natngbint.c
   ${MIALLIB_SRC_DIR}/newlabelcc.c

=== core/doc/Makefile ===

BUILDDIR=../build/doc/
PREFIX=/usr/local

INSTALLDOCDIR=${PREFIX}/share/doc/miallib/lib/

doc: Doxyfile
	mkdir -p $(BUILDDIR)
	doxygen Doxyfile && ./doxy2swig.py -t $(BUILDDIR)/xml/index.xml  $(BUILDDIR)/xml/mial_doxy2swig.i
	cd ../build/doc/latex && make all && mv refman.pdf miallib.pdf

clean: 
	find $(BUILDDIR)/ -delete; mkdir -p $(BUILDDIR)/


all: doc

install:
	mkdir -p ${INSTALLDOCDIR}/pdf && cp -a ../build/doc/latex/miallib.pdf ${INSTALLDOCDIR}/pdf/

uninstall:
	-rm -rf ${INSTALLDOCDIR}/pdf
	-rmdir ${INSTALLDOCDIR}

=== swig/python/Makefile ===
# Makefile adapted by Pierre.Soille@.ec.europa.eu
# for testing jipl C library binding to python

# 20160419: added automatic documentation generation using epydoc
# 20160928: started to use distutils


# ------------------------------------------------------------
# SWIG Examples Makefile
# http://crosswire.org/svn/sword/trunk/bindings/swig/oldmake/Makefile.swig
# [accessed on 20160127]
#
# This file is used by the examples to build modules.  Assuming
# you ran configure, this file will probably work.  However,
# it's not perfect so you might need to do some hand tweaking.
#
# Other notes:
#
# 1.   Take a look at the prefixes below.   Since SWIG works with
#      multiple target languages, you may need to find out where
#      certain packages have been installed.   Set the prefixes
#      accordingly.
#
# 2.   To use this makefile, simply set SRCS, INTERFACE, INCLUDE, LIBS,
#      TARGET, and do a
#           $(MAKE) -f Makefile.template.in SRCS='$(SRCS)' \
#           INCLUDE='$(INCLUDE) LIBS='$(LIBS)' INTERFACE='$(INTERFACE)' \
#           TARGET='$(TARGET)' method
#
#      'method' describes what is being built.
#---------------------------------------------------------------

TARGET     = miallib

ifndef PYTHON
        PYTHON=python
endif

BINDING = python

python_version_full := $(wordlist 2,4,$(subst ., ,$(shell python3 --version 2>&1)))
python_version_major := $(word 1,${python_version_full})
python_version_minor := $(word 2,${python_version_full})
python_version_patch := $(word 3,${python_version_full})

PYVER=${python_version_major}.${python_version_minor}
PYVERSHORT = ${python_version_major}

#GDAL include ../SWIGmake.base
WRAPPER = $(TARGET)_wrap.c

PACKAGE_DIR = ./packages

SWIGOUTPUTDIR = extensions
MIALLIB_ROOT = ../../core/c/
#BUILDDIR = ../build/python/
BUILDDIR = ./build/

PREFIX=/usr/local
INSTALLDOCDIR=${PREFIX}/share/doc/miallib/python/


CC         = gcc
CXX        = c++
prefix     = /usr/local
exec_prefix= ${prefix}
# skipped -DNNI


SWIGARGS = -Wall -I../include -I../include/$(BINDING)
SWIGDEFINES = -DCLASSIF -DODOITHIN -DMCISRG 
CFLAGS     = -fPIC -DDEBUG -DPYTHON -DOPENMP -DLIIAR -DLIBPROJ -DTESTING -DTEST2 -DEERIE -DUNIX -DCLASSIF -DODOITHIN -DMCISRG -std=c99 -m64 -O3 -Wall -fopenmp -c -Wno-unknown-pragmas  
INCLUDE    = -I./  -I$(MIALLIB_ROOT) -I/usr/local/lib/python${PYVER}/dist-packages/numpy/core/include -I/usr/local/lib/python${PYVER}
LIBS       = -lgdal -ltiff -lshp -ldl ../../core/build/lib/lib$(TARGET)_python.so
LIBDIR	   = ../../core/build/lib/
INTERFACE  = $(TARGET).i
SWIGOPT    =
SWIG       = swig
RUNTIMEDIR = $(exec_prefix)/lib

LIBM       = -lieee -lm
LIBC       = 
LIBCRYPT   = -lcrypt
SYSLIBS    = $(LIBM) $(LIBC) $(LIBCRYPT)

libtool_comp = $(TOP)/../Tools/libtool --mode compile
libtool_link = $(TOP)/../Tools/libtool --mode link

# X11 options

XLIB       = -L/usr/X11R6/lib -lX11
XINCLUDE   = -I/usr/X11R6/include

IWRAP      = $(INTERFACE:.i=_wrap.i)
ISRCS      = $(IWRAP:%.i=$(SWIGOUTPUTDIR)/%.c)
ICXXSRCS   = $(IWRAP:.i=.cxx)
IOBJS      = $(IWRAP:%.i=$(BUILDDIR)/temp/$(SWIGOUTPUTDIR)/%.o)


# Symbols used for using shared libraries
SO=		.so
LDSHARED=	gcc -shared
CCSHARED=	-fpic
CXXSHARED=      gcc -shared




##################################################################
#####                       PYTHON                          ######
##################################################################

# Make sure these locate your Python installation
PYTHON_INCLUDE= -DHAVE_CONFIG_H -I/usr/include/python${PYVER}
PYTHON_LIB    = 

# PYTHON_PACKAGES_DIR = /home/soillpi/.local/lib/python${PYVER}/site-packages/
PYTHON_PACKAGES_DIR = /usr/local/lib/python${PYVER}/dist-packages/$(TARGET)/

# Extra Python specific dynamic linking options
PYTHON_DLNK   = 

# ----------------------------------------------------------------
# Build a C dynamically loadable module
# ----------------------------------------------------------------


#$(LIBDIR)/libjip_python.so: 
#	cd ../ljip/src && make $@


build: ../include/$(TARGET).i ../include/$(BINDING)/$(TARGET)_$(BINDING).i ./setup.py $(MIALLIB_ROOT)/$(TARGET)_swig.h
	echo $(PYVERSHORT)
	cat $(MIALLIB_ROOT)/$(TARGET)_*.h | grep '^extern IMAGE \*[a-zA-Z]' | sed 's/extern IMAGE \*/%newobject /' | sed 's/(.*/\;/' | uniq > ../include/$(BINDING)/$(TARGET)_newobjects.i
	python${PYVERSHORT} setup.py build
	mv packages/$(TARGET)/$(TARGET).py  build/lib.linux-x86_64-${PYVER}/$(TARGET)/
	mv packages/$(TARGET)/*_base.py  build/lib.linux-x86_64-${PYVER}/$(TARGET)/
	python${PYVERSHORT} setup.py bdist

$(BUILDDIR)/doc/$(TARGET)_docs_html/toc.html:
	@mkdir -p $(@D) && if [ ${PYVERSHORT} -eq 2 ]; then export LD_LIBRARY_PATH=$(LD_LIBRARY_PATH):../../core/build/lib/ &&  epydoc -v --name $(TARGET) --html --graph all $(BUILDDIR)/lib.linux-x86_64-${PYVER}/$(TARGET)/ -o $(BUILDDIR)/doc/$(TARGET)_docs_html; fi
	if [ ${PYVERSHORT} -eq 2 ]; then echo "[Warning:] This makefile can only create the doc for python2.7 using epydoc.  For python3.6, use makefile in doc subfolder (doc will be created using sphinx)."; fi

$(BUILDDIR)/doc/$(TARGET)_docs_tex/api.tex:
	@mkdir -p $(@D) &&  if [ ${PYVERSHORT} -eq 2 ]; then export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:../../core/build/lib/ && epydoc -v --name $(TARGET) --pdf  --graph all $(BUILDDIR)/lib.linux-x86_64-${PYVER}/$(TARGET)/ -o $(BUILDDIR)/doc/$(TARGET)_docs_tex; fi
	if [ ${PYVERSHORT} -eq 2 ]; then echo "[Warning:] This makefile can only create the doc for python2.7 using epydoc.  For python3.6, use makefile in doc subfolder (doc will be created using sphinx)."; fi






doc: $(BUILDDIR)/doc/$(TARGET)_docs_html/toc.html $(BUILDDIR)/doc/$(TARGET)_docs_tex/api.tex


all: build doc


install:
	python${PYVERSHORT} setup.py install --record $(BUILDDIR)/installed_files.txt
	mkdir -p ${INSTALLDOCDIR}/pdf
	-find ./build/doc/miallib_docs_tex/ -name api.pdf && cp -a ./build/doc/miallib_docs_tex/api.pdf ${INSTALLDOCDIR}/pdf/

uninstall:
	cat $(BUILDDIR)/installed_files.txt | xargs rm -f
	-rm -rf /usr/local/lib/python${PYVER}/dist-packages/miallib
	-rm -rf ${INSTALLDOCDIR}/pdf/

clean:
	if [ x$(SWIGOUTPUTDIR) != 'x' ] && [ -d $(SWIGOUTPUTDIR) ]; then rm -rf ${SWIGOUTPUTDIR}; fi
	if [ x$(BUILDDIR) != 'x' ] && [ -d $(BUILDDIR) ]; then rm -rf ${BUILDDIR}; fi
	-rm -f ../include/$(BINDING)/$(TARGET)_newobjects.i
	-rm -f *.pyc
	-rm -rf *.egg-info
	-rm -f *.so ./osgeo/*.so
	-rm -rf dist
	-rm -f *_wrap.c
	-rm -f packages/*.py
	-rm -f packages/$(TARGET).py
	-rm -f packages/$(TARGET)/$(TARGET).py
	-rm -f packages/$(TARGET)/*.pyc
	-rm -f packages/$(TARGET)/_$(TARGET).so
	-rm -f packages/miallib/*_base.py
	-find . -name "*pyc" -delete
	-rm -f ../include/geometry.i
	-rm -f ../include/imem.i
	-rm -f ../include/io.i
	-rm -f ../include/pointop.i
	-rm -f ../include/convolve.i
	-rm -f ../include/dem.i
	-rm -f ../include/dist.i
	-rm -f ../include/erodil.i
	-rm -f ../include/format.i
	-rm -f ../include/geodesy.i
	-rm -f ../include/hmt.i
	-rm -f ../include/imstat.i
	-rm -f ../include/label.i
	-rm -f ../include/opclo.i
	-rm -f ../include/proj.i
	-rm -f ../include/segment.i
	-rm -f ../include/stats.i


veryclean: clean
	-rm -f ${WRAPPER}
	if [ x$(SWIGOUTPUTDIR) != 'x' ] && [ -d $(SWIGOUTPUTDIR) ]; then rm -rf ${SWIGOUTPUTDIR}; fi

=== swig/python/doc/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = pymia
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
jeolib-miallib (1.1.7-2) unstable; urgency=medium

  * Team upload.
  * Use test-build-validate-cleanup instead of test-build-twice.
  * Add patch to fix library installation path.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 25 Oct 2025 17:41:03 +0200

jeolib-miallib (1.1.7-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Don't include debian revision in symbols version.
  * Update symbols for 32-bit architectures.
  * Enable Salsa CI.
  * Bump Standards-Version to 4.7.2, no changes.
  * Update lintian overrides.
  * Drop Rules-Requires-Root: no, default since dpkg 1.22.13.
  * Update copyright file.
  * Drop patches, applied upstream.
  * Update symbols for 1.1.7.
  * Simplify rules.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 25 Oct 2025 09:15:55 +0200

=== debian/control ===
--- 
+++ 
@@ -18,11 +18,10 @@
                pkgconf,
                swig,
                uthash-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/jeolib-miallib
 Vcs-Git: https://salsa.debian.org/debian-gis-team/jeolib-miallib.git
 Homepage: https://github.com/ec-jrc/jeolib-miallib
-Rules-Requires-Root: no
 
 Package: libmiallib-dev
 Architecture: any
@@ -32,7 +31,7 @@
          ${misc:Depends}
 Recommends: pkgconf
 Description: JRC morphological and image processing library - Development files
- Miallib is a C library including image processing and 
+ Miallib is a C library including image processing and
  mathematical morphology algorithms used by Join Research Center
  in their Big Data Analytics Platform, with binding for Python
  provided.
@@ -46,10 +45,9 @@
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: JRC morphological and image processing library
- Miallib is a C library including image processing and 
+ Miallib is a C library including image processing and
  mathematical morphology algorithms used by Join Research Center
  in their Big Data Analytics Platform, with binding for Python
  provided.
  .
  This package contains the shared library.
-

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/pkg-info.mk

UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

%:
	dh $@ --buildsystem cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(UPSTREAM_VERSION)

=== debian/watch ===
version=4
opts=\
filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1% \
https://github.com/ec-jrc/jeolib-miallib/tags \
(?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
